{**
 * This unit contain the GUI and the logic of the application
 *
 * All this code is under <a href="http://www.gnu.org/copyleft/gpl.html">GNU General Public License</a>
 * @Author <a href="mailto:jolly_arnaud@yahoo.fr">JOLLY Arnaud</a>
 * @version 0.6.0
 *}

{
    JOLLY Arnaud software designer
    Copyright (C) 2006 JOLLY Arnaud

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
}
unit FormMain;
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, ShellAPI, StdCtrls, StrUtils, ImageHoverBtn;
const
  WM_MONICONE = WM_USER +1; ///Message create for the click on the click on tray icon
type
  {**
    GUI of the portable menu
   *}
  TMainForm = class(TForm)
    Back                      : TImage; ///Background image of the menu
    //right part (go to document dir)
    SpeedButtonMyDocuments    : TSpeedButton; /// Button to go on my document folder
    SpeedButtonMyImages       : TSpeedButton; /// Button to go on my image folder
    SpeedButtonMyMusique      : TSpeedButton; /// Button to go on my music folder
    SpeedButtonMyVideo        : TSpeedButton; /// Button to go on my video folder
    SpeedButtonMyKey          : TSpeedButton; /// Button to go on my drive (root of the drive)

    //left part (program)
    LabelDiskSize             : TLabel; /// label show the drive space
    ImageWebLink              : TImage; /// Link to the web : portableapps.com
    AlphaTimer                : TTimer; /// Timer for the alpha effect onshow/hide the menu
    CaptureTimer              : TTimer; /// Timer to hide the window when the menu lose focus
    SpeedButton8              : TSpeedButton; /// Button for launch an application
    SpeedButton7              : TSpeedButton; /// Button for launch an application
    SpeedButton6              : TSpeedButton; /// Button for launch an application
    SpeedButton5              : TSpeedButton; /// Button for launch an application
    SpeedButton4              : TSpeedButton; /// Button for launch an application
    SpeedButton3              : TSpeedButton; /// Button for launch an application
    SpeedButton2              : TSpeedButton; /// Button for launch an application
    SpeedButton1              : TSpeedButton; /// Hover State image for the down button
    TimerMoveUp               : TTimer; /// Timer to go up when more than 8 program in menu
    TimerMoveDown             : TTimer; /// Timer to go down when more than 8 program in menu
    ImageDown                 : TImageHoverBtn; ///Hover image to go down in the menu when more than 8 apps
    ImageUp                   : TImageHoverBtn; ///Hover image to go up in the menu when more than 8 apps
    
    //Quit button
    ImageQuit                 : TImageHoverBtn; ///Hover image to quit the application
    procedure SpeedButtonExecAppClick     (Sender: TObject);
    procedure SpeedButtonQuitClick        (Sender: TObject);
    procedure FormActivate                (Sender: TObject);
    Procedure MessageIcone                (Var Msg: TMsg);Message WM_MONICONE;
    procedure FormCreate                  (Sender: TObject);
    procedure FormDestroy                 (Sender: TObject);
    procedure FormShow                    (Sender: TObject);
    procedure SpeedButtonMyKeyClick       (Sender: TObject);
    procedure SpeedButtonMyDocumentsClick (Sender: TObject);
    procedure SpeedButtonMyImagesClick    (Sender: TObject);
    procedure SpeedButtonMyMusiqueClick   (Sender: TObject);
    procedure SpeedButtonMyVideoClick     (Sender: TObject);
    procedure ImageWebLinkClick           (Sender: TObject);
    procedure AlphaTimerTimer             (Sender: TObject);
    procedure CaptureTimerTimer           (Sender: TObject);
    procedure FormHide                    (Sender: TObject);
    procedure ImageUpMouseEnter(Sender: TObject);
    procedure ImageUpMouseLeave(Sender: TObject);
    procedure ImageDownMouseEnter(Sender: TObject);
    procedure ImageDownMouseLeave(Sender: TObject);
    procedure TimerMoveUpTimer(Sender: TObject);
    procedure TimerMoveDownTimer(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    //Class varible
    TabAppButton            : array [0..7] of TSpeedButton; /// array of Tspeed button for copy the on screen application
    TabIcon                 : array of HICON;
    AlphaIncrease           : boolean; /// Boolean to know if the application must go to show state or the hide state (for alpha animation)
    MyButtonName            : TStringList; /// String list of the Button name
    MyButtonApp             : TStringList; /// String list of the full path of teh button
    CurrentFirstButton      : integer; /// First Button visible in the menu (used for up and down when there is more than 8application to launch)
    //Localisation string (modified in SetLangage prodedure)
    MyDocumentDir           : String; /// Path to the my document
    MyImagesDir             : String; /// Path to the my images
    MyMusicDir              : String; /// Path to the my music
    MyVideoDir              : String; /// Path to the my video
    PathDocumentNotExist    : String; /// Text to create the my document path if not exist
    PathImagesNotExist      : String; /// Text to create the my image path if not exist
    PathMusicNotExist       : String; /// Text to create the my music path if not exist
    PathVideoNotExist       : String; /// Text to create the my video path if not exist
    SizeString              : String; /// String to show the size (with tag)
    //Work function
    procedure ChangeView      (Increase : boolean);
    procedure DirAutoCreate   (Directory : String;CreationString : String);
    procedure InitButtons     ();
    procedure FreeButtons     ();
    procedure PreloadIcon     ();
    procedure FreeIcons       ();
    procedure SetLangage      ();
    procedure WriteAppButtons ();
    function TrtString        (TagString : String) : String;
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm; ///Main form of the project

implementation

uses SizeFunction;

{$R *.dfm}

{**
 * Gnral button use set the menu invisible (reopen with tray icon)
 * and launch the application
 *}
procedure TMainForm.SpeedButtonExecAppClick(Sender: TObject);
var
  iControl : integer;
begin
  for iControl := 0 to length(TabAppButton) do
  begin
    if TObject(TabAppButton[iControl]) = Sender then
    ShellExecute(0,'open', PAnsiChar(MyButtonApp.Strings[iControl+CurrentFirstButton]+#0),Nil, Nil, SW_SHOW);
  end;
end;

{**
 * button to quit the application
 *}
procedure TMainForm.SpeedButtonQuitClick(Sender: TObject);
begin
  Application.Terminate;
end;


{**
 * Set the windows position in bottom right
 *}
procedure TMainForm.FormActivate(Sender: TObject);
begin
  Top := Screen.WorkAreaRect.Bottom-Height;
  Left:= Screen.WorkAreaRect.Right-Width;
end;

{**
 * Function launch when action is made on tray icon
 *}
Procedure TMainForm.MessageIcone(Var MSG:TMSG);
Begin
  If (MSG.wParam=WM_LBUTTONUP) or
     (MSG.wParam=WM_RBUTTONUP)
  Then Begin
      if AlphaIncrease then
      begin
        ChangeView(False);
      end else begin
        ChangeView(True);
      end;
  end;
end;

{**
 * On window creation create the tray icon
 *}
procedure TMainForm.FormCreate(Sender: TObject);
var
  Info:TNotifyIconData;
begin
  //Hide the windows button in task bar (disable Hide,
  //disable close)
  //http://delphi.about.com/od/windowsshellapi/l/aa022701a.htm
  ShowWindow(Application.Handle, SW_HIDE);
  SetWindowLong(Application.Handle, GWL_EXSTYLE,
    GetWindowLong(Application.Handle, GWL_EXSTYLE)
    or WS_EX_TOOLWINDOW );
  ShowWindow(Application.Handle, SW_SHOW);

  //Change application name
  Application.Title:='PortableApps.com - Menu ('+ExtractFileDrive(Application.ExeName)+')';

  //Create tray icon
  Info.cbSize := SizeOf(Info);
  Info.Wnd    := Handle;
  Info.uID    := 1;
  StrCopy(Info.szTip,PAnsiChar(Application.Title+#0));
  Info.hIcon  := Application.Icon.Handle;
  Info.uCallbackMessage := WM_MONICONE;
  Info.uFlags := NIF_TIP Or NIF_ICON Or NIF_MESSAGE;
  Shell_NotifyIcon(NIM_ADD,@Info);

  //Initialize the button with the portable applications Name
  InitButtons();

  //Preload the icon of the application find by the menu
  PreloadIcon();

  //Draw the button for the first time
  WriteAppButtons();

  //Change the langage to the user langage (if not exist english)
  SetLangage();

  //Show the menu when opening the application
  ChangeView(True);
end;

{**
 * Destroy the tray icon when closing the application
 *}
procedure TMainForm.FormDestroy(Sender: TObject);
Var Info:TNotifyIconData;
begin
  Info.cbSize := SizeOf(Info);
  Info.Wnd    := Handle;
  Info.uID    := 1;
  Shell_NotifyIcon(NIM_DELETE,@Info);

  FreeIcons();
  FreeButtons();
end;

{**
 * Change all the tags in tag string
 * @return the new string value replace tag
 *}
function TMainForm.TrtString(TagString : String) : String;
var
  DrvNum : Byte;
  AppPath : String;
  BaseUnit : integer;
  CurrentString : String;
begin
  CurrentString:=TagString;
  AppPath := Application.ExeName;
  DrvNum  := Ord(AppPath[1]);
  BaseUnit:= getSizeBase(DiskSize(DrvNum - $40));

  CurrentString := StringReplace(CurrentString,'$DRIVE',AppPath[1],[rfReplaceAll]);
  CurrentString := StringReplace(CurrentString,'$FREESPACE',inttostr(getSizeValue(DiskFree(DrvNum - $40),BaseUnit)),[rfReplaceAll]);
  CurrentString := StringReplace(CurrentString,'$TOTALSPACE',inttostr(getSizeValue(DiskSize(DrvNum - $40),BaseUnit)),[rfReplaceAll]);
  CurrentString := StringReplace(CurrentString,'$UNIT',getSizeUnit(BaseUnit),[rfReplaceAll]);

  Result := CurrentString;
end;


{**
 * When show the menu calculate the free disk size on the drive
 *}
procedure TMainForm.FormShow(Sender: TObject);
begin
  LabelDiskSize.Caption := TrtString(SizeString);
  CaptureTimer.Enabled:=True;

  //init the two state images to there deffault image
  ImageDown.Picture.Bitmap:=ImageDown.PictureNorm;
  ImageQuit.Picture.Bitmap:=ImageQuit.PictureNorm;
  ImageUp.Picture.Bitmap:=ImageUp.PictureNorm;
end;

{**
 * This procedure open the dirctory in parameter or create it
 * if is not exist*}
procedure TMainForm.DirAutoCreate (Directory : String;CreationString : String);
begin
  if DirectoryExists(Directory) then
  begin
    ShellExecute(0,'open', PAnsiChar(Directory+#0), Nil, Nil, SW_SHOW);
  end else begin
    if MessageBox(Handle,PAnsiChar(CreationString),PAnsiChar(Application.Title),MB_YESNO + MB_ICONQUESTION) = IDYES then
      if ForceDirectories(Directory) then
        ShellExecute(0,'open', PAnsiChar(Directory+#0), Nil, Nil, SW_SHOW);
  end;
end;

{**
 * Open the flash drive in explorer
 *}
procedure TMainForm.SpeedButtonMyKeyClick(Sender: TObject);
var
  DriveToOpen : String;
begin
  DriveToOpen := ExtractFileDrive(Application.ExeName)+'\';
  ShellExecute(0,'open', PAnsiChar(DriveToOpen+#0), Nil, Nil, SW_SHOW);
end;

{**
 * if my document directory exist go in else create it
 * and go in (if user enable create)
 *}
procedure TMainForm.SpeedButtonMyDocumentsClick(Sender: TObject);
var
  WorkDir : String;
begin
  WorkDir:=ExtractFileDrive(Application.ExeName)+MyDocumentDir;
  DirAutoCreate(WorkDir,PathDocumentNotExist);
end;

{**
 * if my images directory exist go in else create it
 * and go in (if user enable create)
 *}
procedure TMainForm.SpeedButtonMyImagesClick(Sender: TObject);
var
  WorkDir : String;
begin
  WorkDir := ExtractFileDrive(Application.ExeName)+MyImagesDir;
  DirAutoCreate(WorkDir,PathImagesNotExist);
end;

{**
 * if my music directory exist go in else create it
 * and go in (if user enable create)
 *}
procedure TMainForm.SpeedButtonMyMusiqueClick(Sender: TObject);
var
  WorkDir : String;
begin
  WorkDir := ExtractFileDrive(Application.ExeName)+MyMusicDir;
  DirAutoCreate(WorkDir,PathMusicNotExist);
end;

{**
 * if my video directory exist go in else create it
 * and go in (if user enable create)
 *}
procedure TMainForm.SpeedButtonMyVideoClick(Sender: TObject);
var
  WorkDir : String;
begin
  WorkDir := ExtractFileDrive(Application.ExeName)+MyVideoDir;
  DirAutoCreate(WorkDir,PathVideoNotExist);
end;


{**
 * Weblink to portable apps website.
 *}
procedure TMainForm.ImageWebLinkClick(Sender: TObject);
begin
  ShellExecute(0,'open','http://portableapps.com/',Nil, Nil, SW_SHOW);
end;


{**
 * Change the view using the timer and the alpha transition
 *}
procedure TMainForm.ChangeView(Increase : boolean);
begin
  if Increase then
  begin
    AlphaTimer.Enabled:=True;
    AlphaIncrease:=True;
    Show;
    //Be sure that the window have the focus
    //Find on MSDN forums : http://forums.microsoft.com/MSDN/ShowPost.aspx?PostID=341805&SiteID=1
    SetFocus;
    SetActiveWindow(Handle);
    SetForegroundWindow(Handle);
  end else begin
    AlphaTimer.Enabled:=True;
    AlphaIncrease:=False;
  end;
end;

{**
 * Timer function used to make the alpha effect on open close menu
 *}
procedure TMainForm.AlphaTimerTimer(Sender: TObject);
begin
  if AlphaIncrease then
  begin
    if AlphaBlendValue<>255 then
      if AlphaBlendValue>=240 then
      begin
        AlphaBlendValue:=255;
        SetFocus();
        AlphaTimer.Enabled:=True;
      end else begin
        AlphaBlendValue:= AlphaBlendValue + 20;
      end;
  end else begin
    if AlphaBlendValue<>0 then
      if AlphaBlendValue <= 20 then
      begin
        Hide;
        AlphaTimer.Enabled:=False;
      end else begin
        AlphaBlendValue := AlphaBlendValue - 20;
      End;
  end;
end;

{**
 * This timer function verify if the current window have loose the focus
 * if the focus is lose the application go in tray
 *}
procedure TMainForm.CaptureTimerTimer(Sender: TObject);
begin
  if getFocus() = 0 then ChangeView(False);
end;

{**
 * Change the interface string to a langage
 * using the langage id of microsoft (using GetUserDefaultLangID to have the currentUser langage)
 * http://msdn.microsoft.com/library/default.asp?url=/library/en-us/intl/nls_238z.asp
 *}
procedure TMainForm.SetLangage();
var
  SystemLangage : Word;
begin
  SystemLangage := GetUserDefaultLangID;

  if (SystemLangage = $040c) or
     (SystemLangage = $080c) or
     (SystemLangage = $0c0c) or
     (SystemLangage = $140c) or
     (SystemLangage = $180c) or
     (SystemLangage = $100c) then
  begin
    //Interface string
    ImageQuit.Hint                := 'Quitter le menu';
    SpeedButtonMyDocuments.Caption:= 'Mes documents';
    SpeedButtonMyImages.Caption   := 'Mes images';
    SpeedButtonMyMusique.Caption  := 'Ma musique';
    SpeedButtonMyVideo.Caption    := 'Mes vidos';
    SpeedButtonMyKey.Caption      := 'Mon lecteur';
    ImageWebLink.Hint             := 'Aller sur le site PortableApps.com';
    SizeString                    := 'Lecteur $DRIVE : $FREESPACE libre sur $TOTALSPACE $UNIT';
    //Document directory path
    MyDocumentDir:= '\Mes documents\';
    MyImagesDir  := '\Mes documents\Mes images\';
    MyMusicDir   := '\Mes documents\Ma musique\';
    MyVideoDir   := '\Mes documents\Mes vidos\';
    //Message boxes for directory not exist
    PathDocumentNotExist := 'Le rpertoire "Mes documents" n''existe pas sur le lecteur.'#13#10'Voulez-vous le crer?';
    PathImagesNotExist   := 'Le rpertoire "Mes images" n''existe pas sur le lecteur.'#13#10'Voulez-vous le crer?';
    PathMusicNotExist    := 'Le rpertoire "Ma musique" n''existe pas sur le lecteur.'#13#10'Voulez-vous le crer?';
    PathVideoNotExist    := 'Le rpertoire "Mes vidos" n''existe pas sur le lecteur.'#13#10'Voulez-vous le crer?';
  end else begin
    //Interface string
    ImageQuit.Hint                := 'Quit the menu';
    SpeedButtonMyDocuments.Caption:= 'My documents';
    SpeedButtonMyImages.Caption   := 'My pictures';
    SpeedButtonMyMusique.Caption  := 'My music';
    SpeedButtonMyVideo.Caption    := 'My video';
    SpeedButtonMyKey.Caption      := 'My drive';
    ImageWebLink.Hint             := 'Go to PortableApps.com website';
    SizeString                    := 'Drive $DRIVE : $FREESPACE free on $TOTALSPACE $UNIT';
    //Document directory path
    MyDocumentDir:= '\Documents\';
    MyImagesDir  := '\Documents\Pictures\';
    MyMusicDir   := '\Documents\Music\';
    MyVideoDir   := '\Documents\Video\';
    //Message boxes for directory not exist
    PathDocumentNotExist := 'The "Documents" directory does not exist.'#13#10'Do you want to create it?';
    PathImagesNotExist   := 'The "Pictures" directory does not exist.'#13#10'Do you want to create it?';
    PathMusicNotExist    := 'The "Music" directory does not exist.'#13#10'Do you want to create it?';
    PathVideoNotExist    := 'The "Video" directory does not exist.'#13#10'Do you want to create it?';
  end;
end;

{**
 * Create the deffault buttons for starting the menu
 *}
procedure TMainForm.InitButtons();
var
  AppPath     : String;
  Info        : TSearchRec;
  InfoSubDir  : TSearchRec;
  TempFileName: String;
  TempSubDir  : String;
  ParentDir   : String;
begin
  MyButtonName := TStringList.Create;
  MyButtonApp  := TStringList.Create;
  AppPath      := ExtractFilePath(Application.ExeName);

  //Set the button for shortcut the portable application in a table
  TabAppButton[0]:=SpeedButton8;
  TabAppButton[1]:=SpeedButton7;
  TabAppButton[2]:=SpeedButton6;
  TabAppButton[3]:=SpeedButton5;
  TabAppButton[4]:=SpeedButton4;
  TabAppButton[5]:=SpeedButton3;
  TabAppButton[6]:=SpeedButton2;
  TabAppButton[7]:=SpeedButton1;

  //Init the first draw button number after this intger is
  //increase or decrease with the TimerMoveUp/TimerMoveDown timer
  CurrentFirstButton := 0;

  //Find the exename of the portableApps (in same dir)
  If FindFirst(AppPath+'*.exe',faAnyFile,Info)=0 Then
  Begin
    Repeat
      If ((Info.Attr And faDirectory)=0) Then
      begin
        if AppPath+Info.FindData.cFileName <> Application.ExeName then
        begin
          //Add the exename and the exePath in the object for the exec
          MyButtonApp.Add(AppPath+Info.FindData.cFileName);
          TempFileName:=Info.FindData.cFileName;
          TempFileName:=LeftStr(TempFileName,length(TempFileName)-4);
          TempFileName:=StringReplace(TempFileName,'Portable','',[rfReplaceAll,rfIgnoreCase]);
          MyButtonName.Add(TempFileName);
        end;
      end;
    Until FindNext(Info)<>0;
  End;

  //Find the exename of the portableApps (in all subdirectory)
  If FindFirst(AppPath+'*',faAnyFile,Info)=0 Then
  Begin
    Repeat
      If ((Info.Attr And faDirectory)<>0) Then
      begin
        TempSubDir := Info.FindData.cFileName;
        if (TempSubDir <> '.') and (TempSubDir <> '..') then
        begin
          //Read the sub directory to find the applcation
          If FindFirst(AppPath+Info.FindData.cFileName+'\*.exe',faAnyFile,InfoSubDir)=0 Then
          Begin
            Repeat
              If ((InfoSubDir.Attr And faDirectory)=0) Then
              begin
                if AppPath+Info.FindData.cFileName <> Application.ExeName then
                begin
                  //Add the exename and the exePath in the object for the exec
                  MyButtonApp.Add(AppPath+Info.FindData.cFileName+'\'+InfoSubDir.FindData.cFileName);
                  TempFileName:=InfoSubDir.FindData.cFileName;
                  TempFileName:=LeftStr(TempFileName,length(TempFileName)-4);
                  TempFileName:=StringReplace(TempFileName,'Portable','',[rfReplaceAll,rfIgnoreCase]);
                  MyButtonName.Add(TempFileName);
                end;
              end;
            Until FindNext(InfoSubDir)<>0;
          End;
        End;
      End;
    Until FindNext(Info)<>0;
  End;

  //In subdirectories off the parent directory
  ParentDir:=ExtractFileDir(ExtractFileDir(Application.ExeName));
  If FindFirst(ParentDir+'\*',faAnyFile,Info)=0 Then
  Begin
    Repeat
      If ((Info.Attr And faDirectory)<>0) Then
      begin
        TempSubDir := Info.FindData.cFileName;
        if (TempSubDir <> '.') and
           (TempSubDir <> '..') and
           (
             StringReplace(
              UpperCase(ParentDir+'\'+Info.FindData.cFileName),
              '\\','\',[rfReplaceAll]) <>
             UpperCase(ExtractFileDir(Application.ExeName))
           ) then
        begin
          //Read the sub directory to find the applcation
          If FindFirst(ParentDir+'\'+Info.FindData.cFileName+'\*.exe',faAnyFile,InfoSubDir)=0 Then
          Begin
            Repeat
              If ((InfoSubDir.Attr And faDirectory)=0) Then
              begin
                //Add the exename and the exePath in the object for the exec
                MyButtonApp.Add(ParentDir+'\'+Info.FindData.cFileName+'\'+InfoSubDir.FindData.cFileName);
                TempFileName:=InfoSubDir.FindData.cFileName;
                TempFileName:=LeftStr(TempFileName,length(TempFileName)-4);
                TempFileName:=StringReplace(TempFileName,'Portable','',[rfReplaceAll,rfIgnoreCase]);
                MyButtonName.Add(TempFileName);
              end;
            Until FindNext(InfoSubDir)<>0;
          End;
        End;
      End;
    Until FindNext(Info)<>0;
  End;


  if MyButtonName.Count > Length( TabAppButton ) then
  begin
    ImageUp.Visible:=True;
  end;
end;

{**
 * free the button in memory
 *}
procedure TMainForm.FreeButtons();
begin
  MyButtonName.free;
  MyButtonApp.free;
end;

{**
 * Remove the focus timer (Using to auto close menu when changing focused app)
 *}
procedure TMainForm.FormHide(Sender: TObject);
begin
  CaptureTimer.Enabled := False;
end;

{**
 * Preload the application icon
 *}
procedure TMainForm.PreloadIcon();
var
  i : integer;
  lpiIcon : word;
begin
  SetLength(TabIcon,MyButtonApp.Count);
  for i:=0 to MyButtonApp.Count - 1 do
  begin
    TabIcon[i] := ExtractAssociatedIcon(hInstance, PChar(MyButtonApp.Strings[i]),lpiIcon);
  end;
end;

{**
 * Free the icon loaded by PreloadIcon
 *}
procedure TMainForm.FreeIcons();
var
  i : integer;
begin
  for i:=0 to MyButtonApp.Count - 1 do
  begin
    DestroyIcon(TabIcon[i]);
  end;
end;

{**
 * Draw all the buton of the application
 *}
procedure TMainForm.WriteAppButtons();
var
  lpiIcon : word;
  h       : hIcon;
  brush   : hBrush;
  iButton : integer;
begin
  for iButton := 0 to length(TabAppButton)-1 do
  begin
    if iButton > MyButtonName.Count - 1 then
    begin
      TabAppButton[iButton].Visible := False;
    end else begin
      //Change the app name
      TabAppButton[iButton].Caption:=MyButtonName.Strings[iButton+CurrentFirstButton];
      TabAppButton[iButton].Hint := MyButtonApp.Strings[iButton+CurrentFirstButton];

      //Get the file icon
      //h := ExtractAssociatedIcon(hInstance, PChar(MyButtonApp.Strings[iButton+CurrentFirstButton]),lpiIcon);

      //Draw the icon in button
      TabAppButton[iButton].Glyph.Canvas.Rectangle(0,0,32,32);
      TabAppButton[iButton].Glyph.TransparentColor := clWhite;
      brush := CreateSolidBrush(RGB(255,255,255));
      DrawIconEx(
        TabAppButton[iButton].Glyph.Canvas.Handle,
        0, 0, TabIcon[iButton+CurrentFirstButton], 32, 32,0,brush,DI_NORMAL);
      DeleteObject(brush);
      TabAppButton[iButton].Glyph.Canvas.Refresh;

      //free the loaded icon after draw it in button
      //DestroyIcon(h);
    end;
  end;
end;

{**
 * Change the up arrow state on mouse over
 * start the up timer
 *}
procedure TMainForm.ImageUpMouseEnter(Sender: TObject);
begin
  //ImageUp.Picture:=ImageUpState2.Picture;
  TimerMoveUp.Enabled:=True;
end;

{**
 * Change the up arrow state on mouse out
 * stop the up timer
 *}
procedure TMainForm.ImageUpMouseLeave(Sender: TObject);
begin
  //ImageUp.Picture:=ImageUpState1.Picture;
  TimerMoveUp.Enabled:=False;
end;

{**
 * Change the down arrow state on mouse out
 * start the down timer
 *}
procedure TMainForm.ImageDownMouseEnter(Sender: TObject);
begin
  //ImageDown.Picture := ImageDownState2.Picture;
  TimerMoveDown.Enabled:=True;
end;

{**
 * Change the down arrow state on mouse in
 * stop the down timer
 *}
procedure TMainForm.ImageDownMouseLeave(Sender: TObject);
begin
  //ImageDown.Picture := ImageDownState1.Picture;
  TimerMoveDown.Enabled:=False;
end;

{**
 * Move the menu button up
 * enable or diable the correspondant bitmap
 *}
procedure TMainForm.TimerMoveUpTimer(Sender: TObject);
begin
  if CurrentFirstButton < ( MyButtonName.Count - length(TabAppButton)) then
  begin
    inc(CurrentFirstButton);
    WriteAppButtons();
    ImageDown.Visible := True;
  end;
  if CurrentFirstButton >= ( MyButtonName.Count - length(TabAppButton)) then
  begin
    ImageUp.Visible :=False;
  end;
end;
{**
 * Move the menu button up
 * enable or diable the correspondant bitmap
 *}
procedure TMainForm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if CurrentFirstButton < ( MyButtonName.Count - length(TabAppButton)) then
  begin
    inc(CurrentFirstButton);
    WriteAppButtons();
    ImageDown.Visible := True;
  end;
  if CurrentFirstButton >= ( MyButtonName.Count - length(TabAppButton)) then
  begin
    ImageUp.Visible :=False;
  end;
end;

{**
 * Move the menu button down (on wheel up)
 * enable or diable the correspondant bitmap
 *}
procedure TMainForm.TimerMoveDownTimer(Sender: TObject);
begin
  if CurrentFirstButton > 0 then
  begin
    dec(CurrentFirstButton);
    WriteAppButtons();
    ImageUp.Visible := True;
  end;
  if CurrentFirstButton <= 0 then
  begin
    ImageDown.Visible :=False;
  end;
end;

{**
 * Move the menu button down (on wheel down)
 * enable or diable the correspondant bitmap
 *}
procedure TMainForm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  if CurrentFirstButton > 0 then
  begin
    dec(CurrentFirstButton);
    WriteAppButtons();
    ImageUp.Visible := True;
  end;
  if CurrentFirstButton <= 0 then
  begin
    ImageDown.Visible :=False;
  end;
end;


end.

